'mdException - by MOD
'2014

'http://docs.oracle.com/javase/6/docs/api/java/lang/Exception.html


#Include Once "md/lang/mdThrowable.bi"


#Ifndef __MDEXCEPTION_BI__
#Define __MDEXCEPTION_BI__

Type mdException Extends mdThrowable
	Public:
	Declare Constructor ()
	Declare Constructor (ByRef message As String)
	Declare Constructor (ByRef message As String, ByRef cause As mdThrowable)
	Declare Constructor (ByRef cause As mdThrowable)
	Declare Virtual Destructor ()
	
	Declare Virtual Function getClass() As String
	Declare Virtual Function toString() As String
	
	Declare Virtual Operator Cast() As String
	
	Protected:
	As mdThrowable Ptr cause
End Type

Constructor mdException()
	'This = This.fillInStackTrace()
	This.cause = @This
End Constructor

Constructor mdException(ByRef message As String)
	'This = This.fillInStackTrace()
	This.detailMessage = message
	This.cause = @This
End Constructor

Constructor mdException(ByRef message As String, ByRef cause As mdThrowable)
	'This = This.fillInStackTrace()
	This.detailMessage = message
	This.cause = @cause
End Constructor

Constructor mdException(ByRef cause As mdThrowable)
	'This = This.fillInStackTrace()
	This.detailMessage = cause.toString()
	This.cause = @cause
End Constructor

Destructor mdException()
	
End Destructor

Function mdException.getClass() As String
	Return "mdException"
End Function

Function mdException.toString() As String
	Dim As String ret
	Dim As String message = This.getLocalizedMessage()
	If message <> "" Then
		ret = "mdException: " & message
	EndIf
	Return ret
End Function

Operator mdException.Cast() As String
	Return This.toString()
End Operator

Operator = (ByRef lhs As mdException, ByRef rhs As mdException) As Integer
	Return Str(lhs) = Str(rhs)
End Operator

#EndIf '__MDEXCEPTION_BI__
