'mdConsoleHandler - by MOD
'2014

'http://docs.oracle.com/javase/6/docs/api/java/util/logging/ConsoleHandler.html


#Include Once "md/util/logging/mdHandler.bi"


#Ifndef __MDCONSOLEHANDLER_BI__
#Define __MDCONSOLEHANDLER_BI__

Type mdConsoleHandler Extends mdHandler
	Public:
	Declare Destructor ()
	
	Declare Virtual /'Abstract'/ Sub close()
	Declare Virtual /'Abstract'/ Sub flush()
	Declare Virtual Function getClass() As String
	Declare Virtual Function getEncoding() As String
	Declare Virtual Function getErrorManager() As mdErrorManager
	Declare Virtual Function getFilter() As mdFilter
	Declare Virtual Function getFormatter() As mdFormatter
	Declare Virtual Function getLevel() As mdLevel
	Declare Virtual Function isLoggable(ByRef record As mdLogRecord) As Boolean
	Declare Virtual /'Abstract'/ Sub publish(ByRef record As mdLogRecord)
	Declare Virtual Sub setEncoding(ByRef enc As String)
	Declare Virtual Sub setErrorManager(ByRef em As mdErrorManager)
	Declare Virtual Sub setFilter(ByRef newFilter As mdFilter)
	Declare Virtual Sub setFormatter(ByRef newFormatter As mdFormatter)
	Declare Virtual Sub setLevel(ByRef newLevel As mdLevel)
	
	Declare Virtual Operator Cast() As String
	
	'Protected:
	Declare Constructor ()
	Protected:
	Declare Virtual Sub reportError(ByRef msg As String, ByRef ex As mdException, ByVal code As Integer)
	
	As String enc
	As mdErrorManager em
	As mdFilter filter
	As mdFormatter formatter
	As mdLevel level
End Type

Constructor mdConsoleHandler()
	
End Constructor

Destructor mdConsoleHandler()
	This.flush()
	This.close()
End Destructor

Sub mdConsoleHandler.close()
	If FALSE Then
		Dim As mdException ex = "Close error"
		This.reportError("Close error", ex, mdErrorManager.CLOSE_FAILURE)
	EndIf
End Sub

Sub mdConsoleHandler.flush()
	If FALSE Then
		Dim As mdException ex = "Flush error"
		This.reportError("Flush error", ex, mdErrorManager.FLUSH_FAILURE)
	EndIf
End Sub

Function mdConsoleHandler.getClass() As String
	Return "mdConsoleHandler"
End Function

Function mdConsoleHandler.getEncoding() As String
	Return This.enc
End Function

Function mdConsoleHandler.getErrorManager() As mdErrorManager
	Return This.em
End Function

Function mdConsoleHandler.getFilter() As mdFilter
	Return This.filter
End Function

Function mdConsoleHandler.getFormatter() As mdFormatter
	Return This.formatter
End Function

Function mdConsoleHandler.getLevel() As mdLevel
	Return This.level
End Function

Function mdConsoleHandler.isLoggable(ByRef record As mdLogRecord) As Boolean
	Return TRUE
End Function

Sub mdConsoleHandler.publish(ByRef record As mdLogRecord)
	If record.getLevel().intValue() >= This.getLevel().intValue() Then
		If This.isLoggable(record) Then
			Dim As String ret
			ret &= This.formatter.getHead(@This)
			ret &= This.formatter.format(record)
			If FALSE Then
				Dim As mdException ex = "Format error"
				This.reportError("Format error", ex, mdErrorManager.FORMAT_FAILURE)
			EndIf
			ret &= This.formatter.getTail(@This)
			If FALSE Then
				Dim As mdException ex = "Open error"
				This.reportError("Open error", ex, mdErrorManager.OPEN_FAILURE)
			EndIf
			Print ret
			If FALSE Then
				Dim As mdException ex = "Write error"
				This.reportError("Write error", ex, mdErrorManager.WRITE_FAILURE)
			EndIf
		EndIf
	EndIf
End Sub

Sub mdConsoleHandler.reportError(ByRef msg As String, ByRef ex As mdException, ByVal code As Integer)
	This.em.error(msg, ex, code)
End Sub

Sub mdConsoleHandler.setEncoding(ByRef enc As String)
	This.enc = enc
End Sub

Sub mdConsoleHandler.setErrorManager(ByRef em As mdErrorManager)
	This.em = em
End Sub

Sub mdConsoleHandler.setFilter(ByRef newFilter As mdFilter)
	This.filter = newFilter
End Sub

Sub mdConsoleHandler.setFormatter(ByRef newFormatter As mdFormatter)
	This.formatter = newFormatter
End Sub

Sub mdConsoleHandler.setLevel(ByRef newLevel As mdLevel)
	This.level = newLevel
End Sub

Operator mdConsoleHandler.Cast() As String
	Return ""
End Operator

Operator = (ByRef lhs As mdConsoleHandler, ByRef rhs As mdConsoleHandler) As Integer
	Return @lhs = @rhs
End Operator

#EndIf '__MDCONSOLEHANDLER_BI__
