'mdQueue - by MOD
'20140208

'http://docs.oracle.com/javase/6/docs/api/java/util/Queue.html


#Include Once "md/util/mdCollection.bi"

#Define mdQueuePtr(E, P) mdQueue##E##P
#Define mdQueue(E, P...) mdQueuePtr(E, P)

#Macro mdQueueDeclarePtr(E, P)

mdCollectionDeclarePtr(E, P)

#Ifndef mdQueue##E##P
'#Define __MDQUEUE_BI__

Type mdQueue##E##P Extends mdCollection##E##P
	Public:
	Declare Constructor ()
	Declare Constructor (ByVal capacity As Integer)
	Declare Constructor (ByRef element_ As E P)
	Declare Constructor (ByRef l As mdCollection##E##P)
	
	Declare Virtual Function add(ByRef element As E P) As Boolean
	Declare Virtual Function element() As E P
	Declare Virtual Function getClass() As String
	Declare Virtual Function offer(ByRef element As E P) As Boolean
	Declare Virtual Function peek_() As E P
	Declare Virtual Function poll() As E P
	Declare Virtual Function remainingCapacity() As Integer
	Declare Virtual Function remove() As E P
	Declare Virtual Function remove(ByVal index As Integer) As E P
	'Declare Virtual Function remove(ByRef o As mdObject) As Boolean
	Declare Virtual Function remove(ByRef o As E P) As Boolean
	
	Declare Virtual Operator Cast() As Integer
	Declare Virtual Operator Cast() As String
	Declare Virtual Operator Let(ByRef c As mdCollection##E##P)
	
	Protected:
	capacity As Integer = (2^31) - 1
End Type

Constructor mdQueue##E##P()
	
End Constructor

Constructor mdQueue##E##P(ByVal capacity As Integer)
	This.capacity = capacity
End Constructor

Constructor mdQueue##E##P(ByRef element_ As E P)
	This.add(element_)
End Constructor

Constructor mdQueue##E##P(ByRef l As mdCollection##E##P)
	This.addAll(l)
End Constructor

Function mdQueue##E##P.add(ByRef element_ As E P) As Boolean
	If This.size() >= This.capacity Then
		Return FALSE
	EndIf
	Dim As mdBasicNode##E##P Ptr currentNode = This.node, prevNode
	While currentNode <> NULL
		prevNode = currentNode
		currentNode = currentNode->nex
	Wend
	
	currentNode = New mdBasicNode##E##P
	If currentNode = NULL Then
		Return FALSE
	Else
		currentNode->value = element_
		If prevNode <> NULL Then
			prevNode->nex = currentNode
		EndIf
		If This.node = NULL Then
			This.node = currentNode
		EndIf
		Return TRUE
	EndIf
End Function

Function mdQueue##E##P.element() As E P
	Dim As mdBasicNode##E##P Ptr currentNode = This.node
	If currentNode <> NULL Then
		Return currentNode->value
	EndIf
	Dim As E P tempRet
	Return tempRet
End Function

Function mdQueue##E##P.getClass() As String
	Return "mdQueue(" & #E & IIf(Len(#P), ", " & #P, "") & ")"
End Function

Function mdQueue##E##P.offer(ByRef element_ As E P) As Boolean
	Return This.add(element_)
End Function

Function mdQueue##E##P.peek_() As E P
	Return This.element()
End Function

Function mdQueue##E##P.poll() As E P
	Return This.remove()
End Function

Function mdQueue##E##P.remainingCapacity() As Integer
	Return This.capacity - This.size()
End Function

Function mdQueue##E##P.remove() As E P
	Return This.remove(0)
End Function

Function mdQueue##E##P.remove(ByVal index As Integer) As E P
	Dim As Integer i = 0
	Dim As mdBasicNode##E##P Ptr currentNode = This.node, nextNode, prevNode
	While currentNode <> NULL
		If i = index Then
			Dim As E P value = currentNode->value
			nextNode = currentNode->nex
			If currentNode = This.node Then
				This.node = nextNode
			EndIf
			Delete currentNode 'If This.isShared = FALSE Then Delete currentNode
			currentNode = nextNode
			If prevNode <> NULL Then
				prevNode->nex = currentNode
			EndIf
			Return value
		EndIf
		
		i += 1
		prevNode = currentNode
		If currentNode <> NULL Then
			currentNode = currentNode->nex
		EndIf
	Wend
	Dim As E P tempRet
	Return tempRet
End Function

Function mdQueue##E##P.remove(ByRef o As E P) As Boolean
	Dim As mdBasicNode##E##P Ptr currentNode = This.node, nextNode, prevNode
	While currentNode <> NULL
		If currentNode->value = o Then
			nextNode = currentNode->nex
			If currentNode = This.node Then
				This.node = nextNode
			EndIf
			Delete currentNode 'If This.isShared = FALSE Then Delete currentNode
			currentNode = nextNode
			If prevNode <> NULL Then
				prevNode->nex = currentNode
			EndIf
			Return TRUE
		EndIf
		prevNode = currentNode
		If currentNode <> NULL Then
			currentNode = currentNode->nex
		EndIf
	Wend
	Return FALSE
End Function

Operator mdQueue##E##P.Cast() As Integer
	Return This.hashCode()
End Operator

Operator mdQueue##E##P.Cast() As String
	Return This.toString()
End Operator

Operator mdQueue##E##P.Let(ByRef c As mdCollection##E##P)
	This.clear()
	This.addAll(c)
End Operator

Operator = (ByRef lhs As mdQueue##E##P, ByRef rhs As mdQueue##E##P) As Boolean
	Return lhs.toString() = rhs.toString()
End Operator

#EndIf '__MDQUEUE_BI__

#EndMacro

#Define mdQueueDeclare(E, P...) mdQueueDeclarePtr(E, P)
